//  $Id: TCPCFSocket.h,v 1.8 2000/12/08 03:51:46 bgg Exp $
//  Maxter
//
//  Created by bgg on Sat Nov 25 2000.
//  Copyright (c) 2000 Object Craft P/L. All rights reserved.

#import <Foundation/Foundation.h>
#import <OmniNetworking/OmniNetworking.h>
#import <OmniBase/rcsid.h>

@interface TCPCFSocket : ONTCPSocket
{
    CFRunLoopSourceRef _runLoopSource;
    CFSocketRef _cfSocketRef;
    CFSocketContext _socketContext;
}

- (void)dealloc;

// action methods
- (void)dataAvailableWithNotification;
- (void)acceptWithNotification;
- (void)readWithNotification;
- (void)removeFromRunLoop;
- (void)acceptConnection;

// internal
- (void)_invalidateSocket;
- (void)_addToRunLoopWithCallBackType:(CFSocketCallBackType)callBackType;
- (void)_processCallBackType:(CFSocketCallBackType)type withData:(NSData *)data;

@end

extern NSString *TCPCFSocketException;
extern NSString *TCPCFSocketArgumentException;

extern NSString *TCPCFSocketDataAvailableNotification;
extern NSString *TCPCFSocketAcceptedNotification;
extern NSString *TCPCFSocketReadCompletionNotification;

extern NSString *TCPCFSocketNotificationONTCPSocketItem;
extern NSString *TCPCFSocketNotificationDataItem;